// C Source File
// Created 25/07/2003; 07:59:51
// Linux TI89 kernel
// v1.0.0 alpha
// It includes all the main functions of Linux TI89
//Matthiaslinux (c) 2003
//matthiasli@ifrance.com

#define USE_TI89              // Compile for TI-89
char _comment[] = "Linux TI89 Kernel v1.0.0 alpha";

#define RETURN_VALUE kr       // Return Pushed Expression

//#define USE_KERNEL						// Use kernel

#define OPTIMIZE_ROM_CALLS		// Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "kernel.h"						// Include kernel header file

// Main Function
void _main(void)
{
	short nbc=0;
	unsigned long p=0;
	char *nom;
	char pass;
	ESI argptr;
	InitArgPtr(argptr);
	char *arg;
  arg = (char*)GetStrnArg (argptr);
	if(strcmp(arg, "version") == 0)
	{
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("1.0.0 alpha");
		push_ANSI_string("v");
		push_ANSI_string("Version");
	}
	else if(strcmp(arg, "start") == 0)
	{
		if(FolderAdd($(temp))==H_NULL)
		{
			while (ESTACK (top_estack) != END_TAG)
			top_estack = next_expression_index (top_estack);
			top_estack--;
			push_END_TAG();
			push_ANSI_string("temp directory already exists");
			push_ANSI_string("er");
			push_ANSI_string("[ERROR]");
		}
		FolderCur($(temp),FALSE);
		expr_create(1, "temp\\started");
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("Kernel started correctly");
		push_ANSI_string("sc");
		push_ANSI_string("[ OK ]");
	}
	else if(strcmp(arg, "shutdown") == 0)
	{
		FolderDel($(temp));
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
		push_ANSI_string("Kernel stopped correctly");
		push_ANSI_string("sc");
		push_ANSI_string("[ OK ]");
	}
	else if(strncmp(arg, "ls", 2) == 0)
	{
		while (ESTACK (top_estack) != END_TAG)
		top_estack = next_expression_index (top_estack);
		top_estack--;
		push_END_TAG();
	if(strcmp(arg+2, "") == 0)
  {
  SYM_ENTRY *SymPtr = SymFindFirst(NULL,4);
    while(SymPtr)
      {
        push_ANSI_string(SymPtr->name);
        SymPtr = SymFindNext();
      }
  }
	else
  {
  SYM_ENTRY *SymPtr = SymFindFirst(SYMSTR(arg+3), 1);
  while(SymPtr)
    {
      push_ANSI_string(SymPtr->name);
      SymPtr = SymFindNext();
    }
  }
	}
	else if(strncmp(arg, "connect ", 8) == 0)
	{
		p=strcspn (arg+8, ":");
		nbc=getexpr("l_etc\\nbuser");
		nom=getstr("l_etc\\us0");
		if(strncmp(arg+8, nom, p-1) == 0)
		{
			pass=getstr("l_etc\\pass0");
			strcp=pass;
			pass=decrypt(pass);
			if(strcmp(arg+8+p, pass) != 0)
			{
			expr_create(0,"temp\\login");
			push_END_TAG();
			push_ANSI_string(nom);
			push_ANSI_string("Connected as");
			push_ANSI_string("co");
			push_ANSI_string("Connection OK");
			goto fin;
			}
		}
		if(nbc>=1)
		{
			nom=getstr("l_etc\\us1");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass1");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(1,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=2)
		{
			nom=getstr("l_etc\\us2");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass2");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(2,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=3)
		{
			nom=getstr("l_etc\\us3");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass3");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(3,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=4)
		{
			nom=getstr("l_etc\\us4");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass4");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(4,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=5)
		{
			nom=getstr("l_etc\\us5");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass5");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(5,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=6)
		{
			nom=getstr("l_etc\\us6");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass6");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(6,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=7)
		{
			nom=getstr("l_etc\\us7");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass7");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(7,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=8)
		{
			nom=getstr("l_etc\\us8");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass8");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(8,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
		if(nbc>=9)
		{
			nom=getstr("l_etc\\us9");
			if(strncmp(arg+8, nom, p-1) == 0)
			{
				pass=getstr("l_etc\\pass9");
				strcp=pass;
				pass=decrypt(pass);
				if(strcmp(arg+8+p, pass) != 0)
				{
				expr_create(9,"temp\\login");
				push_END_TAG();
				push_ANSI_string(nom);
				push_ANSI_string("Connected as");
				push_ANSI_string("co");
				push_ANSI_string("Connection OK");
				goto fin;
				}
			}
		}
	}
	fin:;
	push_LIST_TAG();
}
