// C Source File
// Created 24/07/2003; 18:19:47
//Mouse for RedHat Linux for TI89

#define USE_TI89              // Compile for TI-89

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.01 or higher

#define RETURN_VALUE mr

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "graphx.h"						// Include graphx header file

//Ecran
SCR_RECT ECRAN = {{0, 0, 159, 99}} ;

//affichage d'un sprite
short show_picvar(char *SymName, short x, short y, short Attr)
        {
          SYM_ENTRY *sym_entry = SymFindPtr(SymName, 0);
          if (!sym_entry) return FALSE;
          if (peek(HToESI (sym_entry->handle)) != PIC_TAG) return FALSE;
          BitmapPut(x, y, HeapDeref (sym_entry->handle) + 2, &ECRAN, Attr);
          return TRUE;
        }

//recuprer la valeur d'une expr
float *getexpr(char *Name)  
{  
    SYM_ENTRY *pSym;
		HSym HSymVar;
		HANDLE handle;
		ESI ExprIndex;

		HSymVar = SymFind(SYMSTR(Name));
		pSym = DerefSym(HSymVar);
		handle = pSym->handle;
		ExprIndex = HToESI(handle);
		return GetIntArg(ExprIndex);
}

//creer une expr
void expr_create(const short num, const char *nom_fichier)
{
FILE *pFichier;
pFichier = fopen(nom_fichier,"wb");
fputc(0x00,  pFichier);
fputc(0x03,  pFichier);
fputc(num,  pFichier);
fputc(0x01,  pFichier);
fputc(POSINT_TAG , pFichier);
fclose(pFichier);
}

//fonction attente
void wait(unsigned short n)
{
	asm("
		boucle:
		move.w	#10200,%%d0
		boucle2:
		dbra	%%d0,boucle2
		dbra	%0,boucle
	" :: "d" (n) : "d0") ;
}

//fonction renvoyer le temps d'attente en fonction du temps d'appui
short md(short na)
{
	if(na<2)
	{
		return 8;
	}
	else if(na<5)
	{
		return 3;
	}
	else if(na<10)
	{
		return 0;
	}
	else if(na<20)
	{
		return -1;
	}
	else if(na<30)
	{
		return -2;
	}
	else if(na<40)
	{
		return -3;
	}
	else
	{
		return -4;
	}
}

// Main Function
void _main(void)
{
	//Rcuprer les variable de l'emplacement de la souris
  int x = getexpr("temp\\y");
  int y = getexpr("temp\\x");
  //Cration des variables temp
  short p=1;
  short n=0;
  short na=0;
  //Effacage de la stack
  while (ESTACK (top_estack) != END_TAG)
	top_estack = next_expression_index (top_estack);
	top_estack--;
	short clic=0;
	//Sauvegarde de l'cran
	LCD_BUFFER buffer_mem;
  LCD_save(buffer_mem);
	while(1)
	{
		//Restauration de l'cran et affichage du sprite
		LCD_restore(buffer_mem);
		show_picvar($(souris), y, x, A_NORMAL);
		p=1;
		//Test des touches
		if(!(GX_UPpressed ()==FALSE))
		{
			if(n<=0)
			{
			x=x-1;
			n=md(na);
			if(n<0)
			{
				x=x+n;
			}
			}
			if(x<0)
			{
				x=0;
			}
			na=na+1;
			p=0;
		}
		
		if(!(GX_DOWNpressed ()==FALSE))
		{
			if(n<=0)
			{
			x=x+1;
			n=md(na);
			if(n<0)
			{
				x=x-n;
			}
			if(x>99)
			{
				x=99;
			}
			na=na+1;
			}
			p=0;
		}
		
		if(!(GX_LEFTpressed ()==FALSE))
		{
			if(n<=0)
			{
			y=y-1;
			n=md(na);
			if(n<0)
			{
				y=y+n;
			}
			if(y<0)
			{
				y=0;
			}
			na=na+1;
			}
			p=0;
		}
		
		if(!(GX_RIGHTpressed ()==FALSE))
		{
			if(n<=0)
			{
			y=y+1;
			n=md(na);
			if(n<0)
			{
				y=y-n;
			}
			if(y>159)
			{
				y=159;
			}
			na=na+1;
			}
			p=0;
		}
		
		if(p==1)
		{
			na=0;
		}
		
		if(!(GX_SECONDpressed()==FALSE))
		{
			clic=1;
			goto fin;
		}
		
		if(!(GX_DIAMONDpressed()==FALSE))
		{
			clic=2;
			goto fin;
		}
		wait(2);
		n=n-1;
	}
	fin:
	LCD_restore(buffer_mem);
	//Enregistrer les valeurs de renvoi
	push_shortint(clic);
	expr_create(x, "temp\\y");
	expr_create(y, "temp\\x");
}
